package com.app.input.breeze.board.listutils;


import android.content.Context;
import android.content.Intent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.cardview.widget.CardView;
import androidx.recyclerview.widget.RecyclerView;

import com.app.input.breeze.board.R;
import com.app.input.breeze.board.bean.KeyboardTheme;
import com.app.input.breeze.board.callback.ItemClickListener;
import com.app.input.breeze.board.uiactivity.ThemeDetailActivity;
import com.bumptech.glide.Glide;
import com.app.input.breeze.board.utils.AppUtils;

import java.util.ArrayList;
import java.util.List;

public class RecommendedThemeAdapter extends RecyclerView.Adapter<RecommendedThemeAdapter.ForYouViewHolder> {

    private Context mContext;
    private List<KeyboardTheme> mList = new ArrayList<>();

    private ItemClickListener mCallBack;

    public RecommendedThemeAdapter(Context context) {
        mContext = context;
    }

    public void setForYouList(List<KeyboardTheme> list) {
        this.mList = list;
        notifyDataSetChanged();
    }
    public void setClickAction(ItemClickListener callback) {
        mCallBack = callback;
    }

    @NonNull
    @Override
    public ForYouViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {

        View view = LayoutInflater.from(mContext).inflate(R.layout.recommended_theme_adapter_item, parent, false);
        return new ForYouViewHolder(view);
    }

    @Override
    public void onBindViewHolder(@NonNull ForYouViewHolder holder, int position) {
        KeyboardTheme KeyboardTheme = mList.get(position);
        String thumbGif = KeyboardTheme.getThumbGif();
        String thumb = KeyboardTheme.getThumbUrl();
        if (!thumbGif.isEmpty()) {
            AppUtils.INSTANCE.loadWepJif(mContext, thumbGif, holder.itemImg);
        } else {
            Glide.with(mContext).load(thumb).into(holder.itemImg);
        }

        holder.cardView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intentApply = new Intent(mContext, ThemeDetailActivity.class);
                intentApply.putExtra(ThemeDetailActivity.SOURCE_KEY, KeyboardTheme);
                intentApply.putExtra(ThemeDetailActivity.DISPLAY_URL_KEY, KeyboardTheme.getImgPath());
                intentApply.putExtra(ThemeDetailActivity.ZIP_URL_KEY, KeyboardTheme.getZipPath());
                intentApply.putExtra(ThemeDetailActivity.NAME_KEY, KeyboardTheme.getTitleName());
                intentApply.putExtra(ThemeDetailActivity.GIF_KEY, KeyboardTheme.getImgGif());
                String intent_thumb;
                if (!thumbGif.isEmpty()) {
                    intent_thumb = thumbGif;
                } else {
                    intent_thumb = thumb;
                }
                intentApply.putExtra(ThemeDetailActivity.THUMB_KEY, intent_thumb);
                mContext.startActivity(intentApply);
                if (mCallBack != null) {
                    mCallBack.OnItemClickListener();
                }

            }
        });


    }

    @Override
    public int getItemCount() {
        return mList.size();
    }

    public static class ForYouViewHolder extends RecyclerView.ViewHolder {

        private CardView cardView;
        private ImageView itemImg;

        public ForYouViewHolder(@NonNull View itemView) {
            super(itemView);
            cardView = itemView.findViewById(R.id.card_view);
            itemImg = itemView.findViewById(R.id.imPreview);

        }

    }

//    private void loadWepJif(String webpGifUrl,ImageView view){
//        Glide.with(mContext).load(webpGifUrl).addListener(new RequestListener<Drawable>() {
//            @Override
//            public boolean onLoadFailed(@Nullable GlideException e, @Nullable Object model, @NonNull Target<Drawable> target, boolean isFirstResource) {
//                return false;
//            }
//
//            @Override
//            public boolean onResourceReady(@NonNull Drawable resource, @NonNull Object model, Target<Drawable> target, @NonNull DataSource dataSource, boolean isFirstResource) {
//               if(resource instanceof WebpDrawable){
//                   WebpDrawable webpDrawable = (WebpDrawable) resource;
//                   webpDrawable.setLoopCount(LOOP_FOREVER);
//               }
//
//                return false;
//            }
//        }).into(view);
//    }
}
